#include "sys.h"
#include "usart.h"
#include "lcd.h"
#include "delay.h"

//////////////////////////////////////////////////////////////////
//´,֧printf,Ҫѡuse MicroLIB	  
#if 1
#pragma import(__use_no_semihosting)             
//׼Ҫֺ֧                 
struct __FILE 
{ 
	int handle; 
	/* Whatever you require here. If the only file you are using is */ 
	/* standard output using printf() for debugging, no file handling */ 
	/* is required. */ 
}; 
/* FILE is typedef d in stdio.h. */ 
FILE __stdout;       
//_sys_exit()Աʹðģʽ    
_sys_exit(int x) 
{ 
	x = x; 
} 
//ضfputc 
int fputc(int ch, FILE *f)
{      
	while((USART1->SR&0X40)==0);//ѭ,ֱ   
	USART1->DR = (u8) ch;      
	return ch;
}
#endif 
//end
//////////////////////////////////////////////////////////////////

#ifdef EN_USART1_RX   //ʹ˽   	
//ջ 	
u8 RS485_RX_BUF[64];  	//ջ,64ֽ.
//յݳ
u8 RS485_RX_CNT=0;   
void USART1_IRQHandler(void)
{
	u8 res;	
	//LCD_ShowString(60,100,"zhongduan");	//ʾյ		    
	if(USART1->SR&(1<<5))//յ
	{	 
		res=USART1->DR; 			 
		if(RS485_RX_CNT<64)
		{
			RS485_RX_BUF[RS485_RX_CNT]=res;		//¼յֵ
			RS485_RX_CNT++;						//1 
		} 
	}  											 
} 
#endif  
										 
//ʼIO 1
//pclk2:PCLK2ʱƵ(Mhz)
//bound:
//CHECK OK
//091209
void  RS485_Init(u32 pclk2,u32 bound)
{  	 
	float temp;
	u16 mantissa;
	u16 fraction;	   
	temp=(float)(pclk2*1000000)/(bound*16);//õUSARTDIV
	mantissa=temp;				 //õ
	fraction=(temp-mantissa)*16; //õС	 
    mantissa<<=4;
	mantissa+=fraction; 
	RCC->APB2ENR|=1<<2;   //ʹPORTAʱ  
	RCC->APB2ENR|=1<<14;  //ʹܴʱ 
	GPIOA->CRH&=0XFFFFF00F; 
	GPIOA->CRH|=0X000008B0;//IO״̬
//	GPIOA->ODR|=0<<8;      //PA8 	  
	RCC->APB2RSTR|=1<<14;   //λ1
	RCC->APB2RSTR&=~(1<<14);//ֹͣλ	   	   
	//
 	USART1->BRR=mantissa; // 	 
	USART1->CR1|=0X200C;  //1λֹͣ,Уλ.
#ifdef EN_USART1_RX		  //ʹ˽
	//ʹܽж
	USART1->CR1|=1<<8;    //PEжʹ
	USART1->CR1|=1<<5;    //ջǿжʹ	    	
	MY_NVIC_Init(3,3,USART1_IRQChannel,2);//2ȼ 
#endif
    	RS485_TX_EN=0;			//ĬΪģʽ
}
//RS485lenֽ.
//buf:׵ַ
//len:͵ֽ(Ϊ˺ͱĽƥ,ｨ鲻Ҫ64ֽ)
void RS485_Send_Data(u8 *buf,u8 len)
{
	u8 t;
	RS485_TX_EN=1;			//Ϊģʽ
  	for(t=0;t<len;t++)		//ѭ
	{
		  
		USART1->DR=buf[t];	 
		while((USART1->SR&0X40)==0);//ȴͽ	
	}	 
	while((USART1->SR&0X40)==0);//ȴͽ	
	RS485_RX_CNT=0;	  
	RS485_TX_EN=0;				//Ϊģʽ	
}
//RS485ѯյ
//buf:ջ׵ַ
//len:ݳ
void RS485_Receive_Data(u8 *buf,u8 *len)
{
	u8 rxlen=RS485_RX_CNT;
	u8 i=0;
	*len=0;				//ĬΪ0
	delay_ms(10);		//ȴ10ms,10msûнյһ,Ϊս
	if(rxlen==RS485_RX_CNT&&rxlen)//յ,ҽ
	{
		for(i=0;i<rxlen;i++)
		{
			buf[i]=RS485_RX_BUF[i];	
		}		
		*len=RS485_RX_CNT;	//¼ݳ
		RS485_RX_CNT=0;		//
	}
}


