#include "sys.h"
#include "pwm.h"
#include "delay.h"
#include "usart.h"
  	 

void PWM_T3_Init(u16 arr,u16 psc) 
{ 
	RCC->APB1ENR|=1<<1;//TIM3ʱʹ 
	RCC->APB2ENR|=1<<3;    //ʹPORTBʱ 

	GPIOB->CRL&=0xffffff00;
	GPIOB->CRL|=0x000000BB;  	// PB0,1
	GPIOB->ODR|=3;

	TIM3->ARR=arr;  //趨Զװֵ//պ0.1ms    
	TIM3->PSC=psc;  //ԤƵ7200,õ10Khzļʱ
	 
	TIM3->CR1|=1<<4;//¼ 
    TIM3->CCMR2|=7<<4;  //CH3 PWM2ģʽ	   
    TIM3->CCMR2|=7<<12; //CH3Ԥװʹ 
    TIM3->CCMR2|=1<<3;  //CH4 PWM2ģʽ	   
    TIM3->CCMR2|=1<<11; //CH4Ԥװʹ

	TIM3->CCER|=1<<8;   //OC2 ʹ	   
	TIM3->CCER|=1<<12;   //OC2 ʹ

	TIM3->CR1=0x8000;   //ARPEʹ 
	TIM3->CR1|=0x01;    //ʹܶʱ3  
}

//void PWM_T2_Init(u16 arr,u16 psc)		//ʱ3
//{		 					 
//	//˲ֶ޸IO
//	RCC->APB1ENR|=1<<0;       //TIM2ʱʹ   
//	RCC->APB2ENR|=1<<2;    	 //ʹPORTAʱ
//	  	
//	GPIOA->CRL&=0xFFFFF0FF;
//	GPIOA->CRL|=0x00000B00;  	// A2
//	GPIOA->ODR|=1<<2; 
//	
//
//	TIM2->ARR=arr;//趨Զװֵ 
//	TIM2->PSC=psc;//ԤƵƵ   CK_PSC/(PSC[15:0]+1)
//	
//	TIM2->CCMR2|=7<<4;  //CH3 PWM2ģʽ		 
//	TIM2->CCMR2|=1<<3; //CH3Ԥװʹ	   
//
//	TIM2->CCER|=1<<8;   //OC3 ʹ	   
//
//	TIM2->CR1=0x8000;   //ARPEʹ 
//	TIM2->CR1|=0x01;    //ʹܶʱ3 
//}



//ʱƴӶʱʵ־ȷθ
//TIM2ģʽ
void TIM2_Init_One_Pause(u16 arr,u16 psc)	  //ʱ
{
	RCC->APB1ENR|=1<<0;       //TIM2ʱʹ 

	TIM2->ARR=arr;//趨Զװֵ 
	TIM2->PSC=psc;//ԤƵƵ			  //ʱƵCK_CNTfCK_PSC/(PSC[15:0]+1)
	
	TIM2->CR2|=4<<4;    //OC1REFTRGO	//3λѡģʽ͵ӶʱͬϢ(TRGO)	 

	TIM2->CCMR1|=7<<4;  //CH1 PWM2ģʽ		 
	TIM2->CCMR1|=1<<3;  //CH1Ԥװʹ	   

	TIM2->CCER|=1<<0;   //OC1 ʹ	   
	
	TIM2->CR1=0x8000;   //ARPEʹ 
	TIM2->CR1|=0x09;    //ʹܶʱ3 	  //ڷһθ¼(CENλ)ʱֹͣ
}

//PWMʼ
//arrԶװֵ
//pscʱԤƵ
void TIM3_SLAVE_PWM_Init(u16 arr,u16 psc)	 //Ӷʱ
{		 					 
    RCC->APB1ENR|=1<<1;       //TIM3ʱʹ  
	RCC->APB2ENR|=1<<3;    //ʹPORTBʱ
		   	 
 	RCC->APB2ENR|=1<<0;    //ʱ

	GPIOB->CRL&=0XFFFFFFF0;//PB0
	GPIOB->CRL|=0X0000000B;//ù 	  
	GPIOB->ODR|=1<<0;     //PB0	  

	TIM3->ARR=arr;         //趨Զװֵ 
	TIM3->CCR3=arr/2;	   // 50%ķ
	TIM3->PSC=psc;         //ԤƵ
	
	TIM3->CCMR2|=7<<4;   //CH3 PWM2ģʽ		 
	TIM3->CCMR2|=1<<3;   //CH3Ԥװʹ	   

	TIM3->CCER|=1<<10;   //OC3N ʹ	 
		
	TIM3->SMCR|=5<<0;    //TIM1ſģʽ	     ſģʽ C (TRGI)Ϊʱʱӿ
	                                     //һΪֹͣͣ(λ)ֹͣܿص
	TIM3->SMCR|=0X01<<4; //TIM3ڲTIM3		ڲ1(ITR1)	  ,ڲTIM2
			
	TIM3->CR1|=0x8000;   //ARPEʹ 
	TIM3->CR1|=0x01;     //ʹܶʱ3	    				 									  
}


void PWM1_Init(u16 arr,u16 psc) 		//ʱ14·PWM,PA891011
{	  	  	  
//˲ֶ޸IO    

//////GPIOA//// 
GPIOA->CRH&=0XFFFFFFF0;//PA8 
GPIOA->CRH|=0X0000000B;//ù 
GPIOA->ODR|=1<<8;  


GPIOA->CRH&=0XFFFFFF0F;//PA9 
GPIOA->CRH|=0X000000B0;//ù 
GPIOA->ODR|=1<<9;  
//	
GPIOA->CRH&=0XFFFFF0FF;//PA10 
GPIOA->CRH|=0X00000B00;//ù 
GPIOA->ODR|=1<<10;  

GPIOA->CRH&=0XFFFF0FFF;//PA11 
GPIOA->CRH|=0X0000B000;//ù 
GPIOA->ODR|=1<<11;	


RCC->APB2ENR|=1<<11; //TIM1ʱʹ   
TIM1->ARR=arr;  //趨Զװֵ//պ1ms     
TIM1->PSC=psc;  //ԤƵ7200,õ10Khzļʱ   

TIM1->CCMR1|=6<<4;  //CH1 PWM2ģʽ	   
TIM1->CCMR1|=1<<3; //CH1 Ԥװʹ 

TIM1->CCMR1|=6<<12;  //CH1 PWM2ģʽ	   
TIM1->CCMR1|=1<<11; //CH2Ԥװʹ 

TIM1->CCMR2|=6<<4;  //CH1 PWM2ģʽ	   
TIM1->CCMR2|=1<<3; //CH1Ԥװʹ 

TIM1->CCMR2|=6<<12;  //CH1 PWM2ģʽ	   
TIM1->CCMR2|=1<<11; //CH1Ԥװʹ	    

TIM1->CCER|=1<<0;   //OC1 ʹ 
TIM1->CCER|=1<<4; 
TIM1->CCER|=1<<8; 
TIM1->CCER|=1<<12; 

TIM1->BDTR|=1<<15;  //ʹMOE 

TIM1->CR1|=0x01;    //ʹܶʱ1	    
}




void TIM1_PWM_Init( u16  arr,u16 psc)    //PWMʼ	  //ûԹҪȵһ°
   {
  RCC->APB2ENR|=1<<11;      // ʹܶʱ1ʱ
  RCC->APB2ENR|=1<<2;               //ʹIOAʱ
  RCC->APB2ENR|=1<<3;               //ʹIOBʱ
    
  RCC->APB2ENR|=1<<0;               //ʱ
  GPIOB->CRH&=0X000FFFFF;     // PB13PB14,15״̬Ĵλ 
  GPIOB->CRH|=0XBBB00000;     // 趨PB13PB14,15//TIM1CH1N,TIM1CHH2N CH3N
  GPIOA->CRH&=0XFFFFF000;     // PA8,9,10״̬Ĵλ 
  GPIOA->CRH|=0X00000BBB;     // 趨PA8,9,10ΪùTIM1CH1,2,3

  GPIOB->ODR|=1<<13;
  GPIOB->ODR|=1<<14;
  GPIOB->ODR|=1<<15;       // ͵ƽЧ
  GPIOA->ODR|=1<<8;
  GPIOA->ODR|=1<<9;
  GPIOA->ODR|=1<<10;

  
  TIM1->ARR=arr;        // 趨Զװֵ     
  TIM1->PSC=psc;        // ԤƵƵ
  TIM1->BDTR|=0xCD;        // ʱ趨
  TIM1->CCER|=1<<0;                 // TIM1CH1 ͨ 
  TIM1->CCER|=1<<2;                 // TIM1CH1N ͨ 
  TIM1->CCER|=1<<4;       // TIM1CH2 ͨ 
  TIM1->CCER|=1<<6;                 // TIM4CH2N ͨ 
  TIM1->CCER|=1<<8;       // TIM4CH3 ͨ 
  TIM1->CCER|=1<<10;                // TIM4CH3N ͨ

 

  TIM1->CCMR1|=7<<4;       // TIM1CH1 PWM2ģʽ
  TIM1->CCMR1|=7<<12;      // TIM1CH2 PWM2ģʽ
  TIM1->CCMR2|=7<<4;       // TIM1CH3 PWM2ģʽ
  TIM1->CCMR1|=1<<3;       // TIM1CH1 Ԥװʹ
  TIM1->CCMR1|=1<<11;      // TIM1CH2 Ԥװʹ
  TIM1->CCMR2|=1<<3;       // TIM1CH3 Ԥװʹ 
  TIM1->CR1|=0X80;       // CR1 ARPEԶװԤװλʹ
  TIM1->BDTR|=1<<15;       // ɲʹλ1ͨ
  TIM1->CR1|=0X01;       // ʹܶʱ1
  //TIM1->EGR|=1<<0; 
 }




