 #include "tftlcd.h"
 #include "font.h"
 #include "delay.h"
 #include "usart.h"

 //廭ɫɫ
 u16 POINT_COLOR = 0x0000;
 u16 BACK_COLOR = 0xffff;
 u16 DeviceCode;//ͺ
 void TFTLCD_WriteOrder(u8 order)
{ 
	LCD_RS = 0 ;         //0 д
 	LCD_CS = 0 ; 		 //Ƭѡ
	LCD_DATA = order ; 	 //ݷŵIO
	LCD_WR = 0 ; 		 //
	LCD_WR = 1 ; 
 	LCD_CS = 1 ;   		 //رƬѡ
} 

//ԭ void TFTLCD_WriteData(u16 data)
// TFTLCDд
// data Ҫд
// 
void TFTLCD_WriteData(u16 data)
{
	LCD_RS = 1 ;	     //1 д
 	LCD_CS = 0 ; 		 //Ƭѡ
	LCD_DATA = data ; 	 //ݷŵIO
	LCD_WR = 0 ; 		 //
	LCD_WR = 1 ; 
 	LCD_CS = 1 ;   		 //رƬѡ
} 

//ԭ void TFTLCD_WriteReg(u8 reg_num, u16 reg_value)
// ضĴд
// reg_value ҪдݵļĴ  reg_value : Ҫд
// 
void TFTLCD_WriteReg(u8 reg_num, u16 reg_value) 
{
	TFTLCD_WriteOrder(reg_num) ;    //дĴ
	TFTLCD_WriteData(reg_value) ;   //дҪд
}
 /****дĴ****/
 #if LCD_FAST_IO ==1  //IOдĴ
 void LCD_WR_REG(u8 data)
 {
 	LCD_RS_CLR;    //ѡдַ
	LCD_CS_CLR;	   //Ƭѡͨ
	DATAOUT(data); //
	LCD_WR_CLR;	   //͵ƽ
	LCD_WR_SET;	   //д
	LCD_CS_SET;	   //ƬѡЧ
 }
 #else//IOдĴ
 void LCD_WR_REG(u8 data)
 {
 	LCD_RS=0;      //ѡдַ
	LCD_CS=0;	   //Ƭѡͨ
	DATAOUT(data); //ַ
	LCD_WR=0;	   //͵ƽ
	LCD_WR=1;	   //д
	LCD_CS=1;	   //ƬѡЧ
 }
 #endif

 /****дĴ****/
 void LCD_WriteReg(u8 LCD_Reg, u16 LCD_RegValue)
 {	
	LCD_WR_REG(LCD_Reg);  
	LCD_WR_DATA(LCD_RegValue);	    		 
 }	   

 /**Ĵ**/
 u16 LCD_ReadReg(u8 LCD_Reg)
 {
 	u16 t;
	LCD_WR_REG(LCD_Reg);//дҪļĴ
	GPIOE->CRL=0x88888888; //PB0~PB7
	GPIOE->CRH=0x88888888; //PB8~PB15
	GPIOE->ODR=0xffff;//1
 #if LCD_FAST_IO==1	   //ʹÿIO
 	LCD_RS_SET;//д
	LCD_CS_CLR;//ƬѡЧ
	LCD_RD_CLR;//͵ƽ
	delay_us(5);
 	LCD_RD_SET;//ض
	t=DATAIN;//
	LCD_CS_SET;//ƬѡЧ
 #else
 	LCD_RS=1;
	LCD_CS=0;
	LCD_RD=0;
	LCD_RD=1;
	t=DATAIN;
	LCD_CS=1;
 #endif
 	GPIOE->CRL=0x33333333;	//PB0~PB7
	GPIOE->CRH=0x33333333;	//PB8~PB15
	GPIOE->ODR=0xffff;		//
	return t;			//ض
 }

 /***дGRAM***/
 void LCD_WriteRAM_Reg(void)
 {
 	LCD_WR_REG(R34); //дR34Ĵ
 }
 /***дݵGRAM***/
 void LCD_WriteRAM(u16 RGB_Code)
 {
 	LCD_WR_DATA(RGB_Code);
 }

 /**BGRתRGBʽ**/
 //ILI93xxΪBGRʽдʱΪRGBʽ
 //bgr:BGRʽɫֵ
 //ֵRGBʽɫֵ
 u16 LCD_BGR_RGB(u16 bgr)
 {
 	u16 r,g,b,rgb;
	b=(bgr>>0)&0x1f;
	g=(bgr>>5)&0x3f;
	r=(bgr>>11)&0x1f;
	rgb=(b<<11)+(g<<5)+(r<<0);
	return rgb;
 }

 /**ùλ**/
 //R32Ĵ
 //R33Ĵ
 __inline void LCD_SetCursor(u16 Xpos, u16 Ypos)
 {
 #if USE_HORIZONTAL==1 	 //
		LCD_WriteReg(R32, Ypos);//
		LCD_WriteReg(R33, 319-Xpos);//
 #else					 //
		LCD_WriteReg(R32, Xpos);//
		LCD_WriteReg(R33, Ypos);//
 #endif
 } 

 /***ȡĳɫֵ*****/
 //x:0~239()0~319()
 //y:0~319()0~239()
 //ֵȡõɫֵ
u16 LCD_ReadPoint(u16 x,u16 y)
 {
 	u16 t;
	if(x>=LCD_W||y>LCD_H)
		return 0;//ȡΧ0
	LCD_SetCursor(x,y);//ù굽ĵ
	LCD_WR_REG(R34);//ѡGRAMַ
	GPIOE->CRL=0x88888888;//PB0~PB7
	GPIOE->CRH=0x88888888;//PB8~PB15
	GPIOE->ODR=0xffff;//ȫ
 #if LCD_FAST_IO==1
 	LCD_RS_SET;
	LCD_CS_CLR;
	LCD_RD_CLR;
	LCD_RD_SET;
	delay_us(2);//ʹÿIO΢ʱGRAM2
	LCD_RD_CLR;
	LCD_RD_SET;
	t=DATAIN;
	LCD_CS_SET;
 #else
 	LCD_RS=1;
	LCD_CS=0;
	LCD_RD=0;
	LCD_RD=1;//GRAM2
	LCD_RD=0;
	LCD_RD=1;
	t=DATAIN;
	LCD_CS=1;
 #endif
	GPIOE->CRL=0x33333333; //PB0-7  
	GPIOE->CRH=0x33333333; //PB8-15 
	GPIOE->ODR=0xffff;    //ȫ  
 	return LCD_BGR_RGB(t); //ضתĸõɫֵ
 }

 /***LCDʾ***/
 void LCD_DisplayOn(void)
 {
 	LCD_WriteReg(R7,0x0173);//رLCD
 }
 /***رLCDʾ***/
 void LCD_DisplayOff(void)
 {
 	LCD_WriteReg(R7,0x0000);//رLCD
 }

 /***LCDɨ跽***/
 //0~78
 void LCD_Scan_Dir(u8 dir)
 {
 	u16 value=0;
	u8 reg=0;
 #if USE_HORIZONTAL	 //ʹú
 	switch(dir)
	{
		case 0:dir=6;break;
		case 1:dir=7;break;
		case 2:dir=4;break;
		case 3:dir=5;break;
		case 4:dir=1;break;
		case 5:dir=0;break;
		case 6:dir=3;break;
		case 7:dir=2;break;
	}
 #endif
 	reg=0x03;
	value=1<<12;
	switch(dir)
	{
		case L_R_U_D://,ϵ
			value|=(1<<5)|(1<<4)|(0<<3); 
			break;
		case L_R_D_U://,µ
			value|=(0<<5)|(1<<4)|(0<<3); 
			break;
		case R_L_U_D://ҵ,ϵ
			value|=(1<<5)|(0<<4)|(0<<3);
			break;
		case R_L_D_U://ҵ,µ
			value|=(0<<5)|(0<<4)|(0<<3); 
			break;	 
		case U_D_L_R://ϵ,
			value|=(1<<5)|(1<<4)|(1<<3); 
			break;
		case U_D_R_L://ϵ,ҵ
			value|=(1<<5)|(0<<4)|(1<<3); 
			break;
		case D_U_L_R://µ,
			value|=(0<<5)|(1<<4)|(1<<3); 
			break;
		case D_U_R_L://µ,ҵ
			value|=(0<<5)|(0<<4)|(1<<3); 
			break;	 		
	}
	LCD_WriteReg(reg,value);
 }

 /***ô***/
 //ʼsx,sy;ĩex,ey
 //sx<=ex;sy<=ey
 //hsaregˮƽʼĴַhearegˮƽĴַ
 //vsaregֱʼĴַveargeֱĴַ
 //hsavalˮƽʼꣻheavalˮƽ
 //vsavalֱʼꣻveavalֱ
 
 void LCD_Set_Window(u16 sx,u16 sy,u16 ex,u16 ey)
 {
	u8 hsareg,heareg,vsareg,veareg;
	u16 hsaval,heaval,vsaval,veaval;  
 #if USE_HORIZONTAL  //ʹú	
	//ֵ
	hsaval=sy;				
	heaval=ey;
	vsaval=319-ex;
	veaval=319-sx;	
 #else				//
	//ֵ
	hsaval=sx;				
	heaval=ex;
	vsaval=sy;
	veaval=ey;	
 #endif
	hsareg=0x50;heareg=0x51;//ˮƽ򴰿ڼĴ
	vsareg=0x52;veareg=0x53;//ֱ򴰿ڼĴ	  
	//üĴֵ
	LCD_WriteReg(hsareg,hsaval);
	LCD_WriteReg(heareg,heaval);
	LCD_WriteReg(vsareg,vsaval);
	LCD_WriteReg(veareg,veaval);
 }

 /***LCD***/
 //colorΪɫ
 void LCD_Clear(u16 color)
 {
 	u32 num=0;
	LCD_SetCursor(0x00,0x0000);//ùλ
	LCD_WR_REG(R34);   //ʼдGRAM
	for(num=0;num<76800;num++)
	{
		LCD_WR_DATA(color);
	}
 }

 /***ɫ***/
 void LCD_Fill(u16 xsta,u16 ysta,u16 xend,u16 yend,u16 color)
 {  
	u32 i;
	u32 len=0;
	LCD_Set_Window(xsta,ysta,xend,yend);
 	LCD_SetCursor(xsta,ysta);      	//ùλ 
	LCD_WR_REG(R34);     //ʼдGRAM
	len=(xend-xsta+1)*(yend-ysta+1);	//дݳ
	for(i=0;i<len;i++)
		LCD_WR_DATA(color);
 #if USE_HORIZONTAL  //ʹú	
	LCD_Set_Window(0,0,319,239);
 #else
	LCD_Set_Window(0,0,239,319);
 #endif	    					  	    
 }  
 
 /***㺯***/
 //ǰPOINT_COLORɫ
 void LCD_DrawPoint(u16 x,u16 y)
 {
 	LCD_SetCursor(x,y);//ùλ
	LCD_WR_REG(R34);//ʼдGRAM
	LCD_WR_DATA(POINT_COLOR);
 }

 /***ߺ***/
 //x1y1ʼꣻx2y2
 void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2)
 {
	u16 t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 

	delta_x=x2-x1; // 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; //õ 
	else if(delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )// 
	{  
		LCD_DrawPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
 }    

 /******/
 void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2)
 {
	LCD_DrawLine(x1,y1,x2,y1);
	LCD_DrawLine(x1,y1,x1,y2);
	LCD_DrawLine(x1,y2,x2,y2);
	LCD_DrawLine(x2,y1,x2,y2);
 }

 /***Բ***/
 void Draw_Circle(u16 x,u16 y,u8 r)
 {
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		LCD_DrawPoint(x-b,y-a);             //3           
		LCD_DrawPoint(x+b,y-a);             //0           
		LCD_DrawPoint(x-a,y+b);             //1       
		LCD_DrawPoint(x-b,y-a);             //7           
		LCD_DrawPoint(x-a,y-b);             //2             
		LCD_DrawPoint(x+b,y+a);             //4               
		LCD_DrawPoint(x+a,y-b);             //5
		LCD_DrawPoint(x+a,y+b);             //6 
		LCD_DrawPoint(x-b,y+a);             
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		LCD_DrawPoint(x+a,y+b);
	}
 } 

 /*****************ʾһַ**************/
 //x:0~234
 //y:0~308
 //num:Ҫʾַ:" "--->"~"
 //size:С 12/16
 //mode:ӷʽ(1)Ƿǵӷʽ(0)
 void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode)
 {  
 #if USE_HORIZONTAL==1	 //
 #define MAX_CHAR_POSX 312
 #define MAX_CHAR_POSY 232 
 #else     
 #define MAX_CHAR_POSX 232
 #define MAX_CHAR_POSY 312
 #endif 
    u8 temp;
    u8 pos,t;
	u16 x0=x;
	u16 colortemp=POINT_COLOR;      
    if(x>MAX_CHAR_POSX||y>MAX_CHAR_POSY)return;	    
	//ô		   
	num=num-' ';//õƫƺֵ
	if(!mode) //ǵӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)POINT_COLOR=colortemp;
				else POINT_COLOR=BACK_COLOR;
				LCD_DrawPoint(x,y);	
				temp>>=1; 
				x++;
		    }
			x=x0;
			y++;
		}	
	}else//ӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)LCD_DrawPoint(x+t,y+pos);//һ     
		        temp>>=1; 
		    }
		}
	}
	POINT_COLOR=colortemp;	    	   	 	  
 }   
 //m^n
 u32 mypow(u8 m,u8 n)
 {
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
 }		
 	 
 /****************ʾ******************/
 //x,y :	 
 //len :ֵλ
 //size:С
 //color:ɫ
 //num:ֵ(0~4294967295);	 
 void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size)
 {         	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size/2)*t,y,' ',size,0);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,0); 
	}
 } 

 /*********ʾ2********/
 //x,y:
 //size:С
 //mode:ģʽ	0,ģʽ;1,ģʽ
 //num:ֵ(0~99);	 
 void LCD_Show2Num(u16 x,u16 y,u16 num,u8 len,u8 size,u8 mode)
 {         	
	u8 t,temp;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,mode); 
	}
 } 

 /******************ʾַ**************/
 //x,y:  
 //*p:ַʼַ
 //16
 void LCD_ShowString(u16 x,u16 y,const u8 *p)
 {         
    while(*p!='\0')
    {       
        if(x>MAX_CHAR_POSX){x=0;y+=16;}
        if(y>MAX_CHAR_POSY){y=x=0;LCD_Clear(GRAY);}
        LCD_ShowChar(x,y,*p,16,1);
        x+=8;
        p++;
    }  
 }
 /**********LCDʼ*******************/
void LCD_Init(void)
{
////-------------------ģʾϵͳ-------------------//
 	RCC->APB2ENR |= 1<<2;   //ʹPORTAʱ
 	RCC->APB2ENR |= 1<<4;   //ʹPORTCʱ
	RCC->APB2ENR |= 1<<6;   //ʹPORTEʱ
	RCC->APB2ENR |= 1<<0;   //ʱ
//	JTAG_Set(SWD_ENABLE);   //SWD
											 
//	//PORTC45 	
//	GPIOA->CRL &= 0XFFFF00FF;
//	GPIOA->CRL |= 0X00003300;  
    //PA0123
//	GPIOA->CRL &= 0XFFFF0000;
//	GPIOA->CRL |= 0X00003333; 
//	GPIOA->ODR |= 0X000F;  	 	  //RDΪߵƽ
//	GPIOC->CRL &= 0XFFFF00FF;
//	GPIOC->CRL |= 0X00003300; 
//	GPIOC->ODR |= 0X000C;  	 	  //RDΪߵƽ
//	//PORTE  	
//	GPIOE->CRH=0X33333333;
//	GPIOE->CRL=0X33333333; 	 
//	GPIOE->ODR=0XFFFF;

	GPIOA->CRL&=0XFFFFFF00;
	GPIOA->CRL|=0X00000033;
	GPIOA->ODR|=0x0003;
	//PORTE  	
	GPIOE->CRH=0X33333333;
	GPIOE->CRL=0X33333333; 	 
	GPIOE->ODR=0XFFFF;

 	
	GPIOC->CRL&=0XFFFF0000;
	GPIOC->CRL|=0X00003333;
	GPIOC->ODR|=0X000F;

//	delay_ms(50); // delay 50 ms 
//	LCD_WriteReg(0x0000,0x0001);
//	delay_ms(50); // delay 50 ms 
//	DeviceCode = LCD_ReadReg(0x0000); 
	
//	//-----lcdλ-----//
//	LCD_RESET = 1 ;
//	delay_ms(5) ;
//	LCD_RESET = 0 ;	    //λ
//	delay_ms(50) ;
//	LCD_RESET = 1 ;
//	delay_ms(50);  
////	 

	LCD_WriteReg(0x00,0x0001);
	LCD_WriteReg(0x01,0x0100);	//Driver Output Contral.
	LCD_WriteReg(0x02,0x0700);	//LCD Driver Waveform Contral.
	LCD_WriteReg(0x03,0x1030);  //Entry Mode Set.
	LCD_WriteReg(0x04,0x0000);	//Scalling Contral.
	LCD_WriteReg(0x08,0x0202);	//Display Contral 2.(0x0207)
	LCD_WriteReg(0x09,0x0000);	//Display Contral 3.(0x0000)
	LCD_WriteReg(0x0a,0x0000);	//Frame Cycle Contal.(0x0000)
	LCD_WriteReg(0x0c,(1<<0));	//Extern Display Interface Contral 1.(0x0000)
	LCD_WriteReg(0x0d,0x0000);	//Frame Maker Position.
	LCD_WriteReg(0x0f,0x0000);	//Extern Display Interface Contral 2.	    
	delay_ms(50); 
	LCD_WriteReg(0x07,0x0101);	//Display Contral.
	delay_ms(50); 								  
	LCD_WriteReg(0x10,(1<<12)|(0<<8)|(1<<7)|(1<<6)|(0<<4));	//Power Control 1.(0x16b0)
	LCD_WriteReg(0x11,0x0007);								//Power Control 2.(0x0001)
	LCD_WriteReg(0x12,(1<<8)|(1<<4)|(0<<0));				//Power Control 3.(0x0138)
	LCD_WriteReg(0x13,0x0b00);								//Power Control 4.
	LCD_WriteReg(0x29,0x0000);								//Power Control 7.

	LCD_WriteReg(0x2b,(1<<14)|(1<<4));	    
	LCD_WriteReg(0x50,0);	//Set X Star
	//ˮƽGRAMֹλSet X End.
	LCD_WriteReg(0x51,239);	//Set Y Star
	LCD_WriteReg(0x52,0);	//Set Y End.t.
	LCD_WriteReg(0x53,319);	//

	LCD_WriteReg(0x60,0x2700);	//Driver Output Control.
	LCD_WriteReg(0x61,0x0001);	//Driver Output Control.
	LCD_WriteReg(0x6a,0x0000);	//Vertical Srcoll Control.

	LCD_WriteReg(0x80,0x0000);	//Display Position? Partial Display 1.
	LCD_WriteReg(0x81,0x0000);	//RAM Address Start? Partial Display 1.
	LCD_WriteReg(0x82,0x0000);	//RAM Address End-Partial Display 1.
	LCD_WriteReg(0x83,0x0000);	//Displsy Position? Partial Display 2.
	LCD_WriteReg(0x84,0x0000);	//RAM Address Start? Partial Display 2.
	LCD_WriteReg(0x85,0x0000);	//RAM Address End? Partial Display 2.

	LCD_WriteReg(0x90,(0<<7)|(16<<0));	//Frame Cycle Contral.(0x0013)
	LCD_WriteReg(0x92,0x0000);	//Panel Interface Contral 2.(0x0000)
	LCD_WriteReg(0x93,0x0001);	//Panel Interface Contral 3.
	LCD_WriteReg(0x95,0x0110);	//Frame Cycle Contral.(0x0110)
	LCD_WriteReg(0x97,(0<<8));	//
	LCD_WriteReg(0x98,0x0000);	//Frame Cycle Contral.	   
	LCD_WriteReg(0x07,0x0173);	//(0x0173)

	LCD_BL=1;//LCD
	LCD_Scan_Dir(L_R_U_D);//ɨ跽򣬴ϵ£
	LCD_Clear(WHITE);//
	
 }
 void  Draw_Circle3_3(u16 x,u16 y) //3*3
{
	   POINT_COLOR=RED;
	   LCD_DrawPoint(x-1,y-1);
	   LCD_DrawPoint(x-1,y);
	   LCD_DrawPoint(x-1,y+1);
	   LCD_DrawPoint(x,y-1);
	   LCD_DrawPoint(x,y);
	   LCD_DrawPoint(x,y+1);
	   LCD_DrawPoint(x+1,y-1);
	   LCD_DrawPoint(x+1,y);
	   LCD_DrawPoint(x+1,y+1);
}
void  Draw_BAXIN(void)	 //ͼ
{
	POINT_COLOR=BLACK;//Ϊɫ
	/*	       Բ		 */
	Draw_Circle(120,120,20);  
	Draw_Circle(120,120,40);
	Draw_Circle(120,120,60);
	Draw_Circle(120,120,80);
	Draw_Circle(120,120,100);
	Draw_Circle(120,120,120);
	/*	       -X		 */
	LCD_ShowNum(7,112,5,1,16);	
	LCD_ShowNum(27,112,6,1,16);
	LCD_ShowNum(47,112,7,1,16);
	LCD_ShowNum(67,112,8,1,16);
	LCD_ShowNum(87,112,9,1,16);
	/*	       (0,0)		 */
	LCD_ShowNum(113,112,10,2,16);  
	/*	       +X		 */
	LCD_ShowNum(147,112,9,1,16);  
	LCD_ShowNum(167,112,8,1,16);
	LCD_ShowNum(187,112,7,1,16);
	LCD_ShowNum(207,112,6,1,16);
	LCD_ShowNum(227,112,5,1,16); 
	/*	       +Y		 */
	LCD_ShowNum(116,2,9,1,16);  
	LCD_ShowNum(116,22,8,1,16);
	LCD_ShowNum(116,42,7,1,16);
	LCD_ShowNum(116,62,6,1,16);
	LCD_ShowNum(116,82,5,1,16);
	/*	       -Y		 */
	LCD_ShowNum(116,142,9,1,16);  
	LCD_ShowNum(116,162,8,1,16);
	LCD_ShowNum(116,182,7,1,16);
	LCD_ShowNum(116,202,6,1,16);
	LCD_ShowNum(116,222,5,1,16);
	/*	       б	     */
	LCD_DrawLine(35,205,205,35);//ֱX
	LCD_DrawLine(35,35,205,205);//ֱ-X
//	LCD_DrawLine(120,0,120,240);//ֱY
//	LCD_DrawLine(0,120,240,120);//ֱX

}

void TFTLCD_ClearScreen(u16 color)
{
	u32 index=0;      
	TFTLCD_SetXy(0x00,0x0000);//ùλ 
	TFTLCD_WriteRAM_Prepare();     //ʼдGRAM	 	  
	for(index=0;index<76800;index++)
	{
		TFTLCD_WriteData(color);    
	}
}  

//ԭ void TFTLCD_SetXy(u8 x_add, u8 y_add)
// 趨λ
// x_add : Xλ        y_add Yλ 
// 
void TFTLCD_SetXy(u16 Xpos, u16 Ypos)
{
//	TFTLCD_WriteReg(R32, y_add);
//	TFTLCD_WriteReg(R33, 319-x_add);
	TFTLCD_WriteReg(R32, Xpos);
	TFTLCD_WriteReg(R33, Ypos);	
}


//ԭ void TFTLCD_WriteRAM_Prepare(void)
// ʼдGRAM
//  
// 
void TFTLCD_WriteRAM_Prepare(void)
{
	TFTLCD_WriteOrder(R34);	
}
//ԭ void TFTLCD_DrawPoint(u16 x_add, u16 y_add)
// ضط
// x_add :  
// 
void TFTLCD_DrawPoint(u16 x, u16 y)
{
	TFTLCD_SetXy(x,y);
	TFTLCD_WriteOrder(R34);//ʼдGRAM
//	TFTLCD_WriteRAM_Prepare();
	TFTLCD_WriteData(POINT_COLOR) ;
}

//ԭ void TFTLCD_WriteStr(u8 x_add, u8 y_add, u16 back_color, u16 str_color,u8 str)
// ڣx_add,y_addдַ
//  str : Ҫʾĵַ
// 
void TFTLCD_WriteStr(u16 x_add, u16 y_add,u8 str)
{
	u8 temp;
    u8 pos,t;
	u16 temp_pointcolor ;	   
	str = str-' ';//õƫƺֵ
	for(pos=0;pos<16;pos++)
	{
		TFTLCD_SetXy(x_add,y_add) ;	 //趨X,YһҪһ
		TFTLCD_WriteRAM_Prepare() ;

    	temp=asc2_1608[str][pos];		 //1608
		for(t=0;t<8;t++)
	    {                 
	        if(temp&0x01)temp_pointcolor = RED;
			else temp_pointcolor = WHITE ;
			TFTLCD_WriteData(temp_pointcolor) ;	
			temp >>= 1; 
			x_add ++;
	    }
		x_add -= 8 ;
		y_add += 1 ;
	}	
} 
//ԭ void TFTLCD_WriteString(u8 x_add,u8 y_add,u8 *string)
// (x_add,y_addдַ
//  string : Ҫʾַ
// 
void TFTLCD_WriteString(u16 x_add,u16 y_add,u8 *string)
{
	u8 i = 0;
	while(*(string+i))
	{
		TFTLCD_WriteStr(x_add, y_add, *(string+i));
		x_add += 8;
		i ++;
	 }	
}
//ԭ void TFTLCD_WriteChinese(u8 x_add,u8 y_add,u8 *hz)
// (x_add,y_addд
//  *hz : Ҫʾĺ
// 
void TFTLCD_WriteChinese(u16 x_add,u16 y_add,u8 *hz)
{
	u8 k,i,t,temp;
	//ҵҪдĺǵڼ
    for(k = 0; k< sizeof(GB_16)/sizeof(GB_16[0]); k++)//Һֱеĺ
    {
		if(hz[0] == GB_16[k].Index[0] && hz[1] == GB_16[k].Index[1])
		break;
    }
	//д
	for(i = 0; i < 16; i++)
	{
		TFTLCD_SetXy(x_add,y_add) ;	 //趨X,YһҪһ
		TFTLCD_WriteRAM_Prepare() ;
		//дiеĵһַ
    	temp=GB_16[k].Msk[2*i];		 //1608
		for(t=0;t<8;t++)
	    {                 
	        if(temp&0x01)POINT_COLOR = RED;
			else POINT_COLOR = WHITE ;
			TFTLCD_WriteData(POINT_COLOR) ;	
			temp >>= 1; 
			x_add ++;
	    }
		//дiеĵڶַ
    	temp=GB_16[k].Msk[2*i+1];		 //1608
		for(t=0;t<8;t++)
	    {                 
	        if(temp&0x01)POINT_COLOR = RED;
			else POINT_COLOR = WHITE ;
			TFTLCD_WriteData(POINT_COLOR) ;	
			temp >>= 1; 
			x_add ++;
	    }
		x_add -= 16 ;
		y_add += 1 ;
	}
}
//ԭ void TFTLCD_WriteChineseStr(u8 x_add,u8 y_add,u8 *str)
// (x_add,y_addдִ
//  *str : Ҫʾĺִ
// 
void TFTLCD_WriteChineseStr(u16 x_add,u16 y_add,u8 *str)
{
	u8 i = 0; 
	while(str[i])
	{
	    TFTLCD_WriteChinese(x_add,y_add,&str[i]);
	    x_add += 16;
	    i += 2;
	}
}
void TFTLCD_ShowNum(u16 x,u16 y,u32 num,u8 len)
{         	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				TFTLCD_WriteStr(x+8*t,y,' ');
				continue;
			}else enshow=1; 
		 	 
		}
	 	TFTLCD_WriteStr(x+8*t,y,temp+'0'); 
	}
}


void LCD_zhongwen(u16 x,u16 y,u8 num,u8 size,u8 mode)
{  
#if USE_HORIZONTAL==1
#define MAX_CHAR_POSX 312
#define MAX_CHAR_POSY 232 
#else     
#define MAX_CHAR_POSX 232
#define MAX_CHAR_POSY 312
#endif 
    u8 temp;
    u8 pos,t;
	u16 x0=x;
	u16 colortemp=POINT_COLOR;      
    if(x>MAX_CHAR_POSX||y>MAX_CHAR_POSY)return;	    
	//ô		   
//	num=num-' ';//õƫƺֵ
	if(!mode) //ǵӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)POINT_COLOR=colortemp;
				else POINT_COLOR=BACK_COLOR;
				LCD_DrawPoint(x,y);	
				temp>>=1; 
				x++;
		    }
			x=x0;
			y++;
		}	
	}else//ӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)LCD_DrawPoint(x+t,y+pos);//һ     
		        temp>>=1; 
		    }
		}
	}
	POINT_COLOR=colortemp;	    	   	 	  
} 

