#ifndef _ISD1760_H 
#define _ISD1760_H 

#include "sys.h"
//ÿ10Լ80ʮƵַʮ0x50,һԽ
//ֻᲥǰĺһ֣EOMֹͣ.Ը 
//¼8תʮõŵַ΢

#define  PU          0x01 
#define  STOP        0x02 
#define  RESET       0x03 
#define  CLR_INT     0x04 
#define  RD_STATUS   0x05 
#define  RD_PLAY_PTR 0x06 
#define  PD          0x07 
#define  RD_REC_PTR  0x08 
#define  RD_DEVID    0x09 
#define  G_ERASE     0x43 
#define  RD_APC      0x44 
#define  WR_APC1     0x45 
#define  WR_APC2     0x65 
#define  WR_NVCFG    0x46 
#define  CHK_MEM     0x49 
#define  SET_PLAY    0x80 
#define  SET_REC     0x81 
#define  SET_ERASE   0x82 

#define  HIGH 1 
#define  LOW  0 

#define SS   PBout(12) 
#define SCLK PBout(13) 
#define MOSI PBout(15) 
#define MISO PBin(14) 

extern u8 SR0_L; 
extern u8 SR0_H; 
extern u8 SR1; 
extern u8 ID,APCL,APCH; 
extern u8 SBUF;

void ISD_SPI_Init(void);

/************************************************************************** 
*    ԭ: void ISD_Init(void); 
*        : ʼ 
**************************************************************************/ 
void  ISD_Init(void); 

/************************************************************************** 
*    ԭ: void ISD_PU(void); 
*        : ϵ 
**************************************************************************/ 
void ISD_CHK_MEM(void); 

/************************************************************************** 
*    ԭ: void ISD_Up(void); 
*        : ϵ 
**************************************************************************/ 
void  ISD_PU(void); 

/************************************************************************** 
*    ԭ: void ISD_Stop(void); 
*        : ֹͣ 
**************************************************************************/ 
void ISD_Stop(void); 

/************************************************************************** 
*    ԭ: void ISD_Reset(void); 
*        : λ 
**************************************************************************/ 
void ISD_Reset(void); 

/************************************************************************** 
*    ԭ: void ISD_PD(void); 
*        :  
**************************************************************************/ 
void ISD_PD(void); 

/************************************************************************** 
*    ԭ: void ISD_SendData(u8 BUF_ISD); 
*        :  
**************************************************************************/ 
u8 ISD_SendData(u8 BUF_ISD); 

/************************************************************************** 
*    ԭ: void RdStatus(void); 
*        : ȡ״̬ 
**************************************************************************/ 
void RdStatus(void); 

/************************************************************************** 
*    ԭ: void RdStatus(void); 
*        : ȡID 
**************************************************************************/ 
u8 RD_DevID(void); 

/************************************************************************** 
*    ԭ: void RD_APC(void); 
*        : ȡAPC 
**************************************************************************/ 
void RdAPC(void); 

/************************************************************************** 
*    ԭ: void ClrInt(void); 
*        : ж 
**************************************************************************/ 
void ClrInt(void); 

/************************************************************************** 
*    ԭ: void ISD_WR_APC2(u8 voiceValue); 
*        : WR_APC2 
**************************************************************************/ 
void ISD_WR_APC2(u8 voiceValue); 

/************************************************************************** 
*    ԭ: void ISD_WR_NVCFG(void); 
*        : дĴ 
**************************************************************************/ 
void ISD_WR_NVCFG(void); 

/************************************************************************** 
*    ԭ: void SetPLAY(u8 cNum); 
*        : 㲥 
**************************************************************************/ 
void SetPLAY(u8 cNum); 

/************************************************************************** 
*    ԭ: void SetREC(u8 cNum); 
*        : ¼ 
**************************************************************************/ 
void SetREC(u8 cNum); 


/************************************************************************** 
*    ԭ: void Erase_All(void); 
*        : ȫɾ 
**************************************************************************/ 
void Erase_All(void); 

/************************************************************************** 
*    END 
*    END 
**************************************************************************/ 
#endif 
