#ifndef __PID_H
#define __PID_H	 
#include "sys.h"
/*====================================================================================================
PID Function
The PID (֡΢) function is used in mainly
control applications. PIDCalc performs one iteration of the PID
algorithm.
While the PID function works, main is just a dummy program showing
a typical usage.
=====================================================================================================*/
typedef struct PID {
    int SetPoint; // 趨ĿDesired value
    float Proportion; // Proportional Const
    float Integral; // ֳIntegral Const
    float Derivative; // ΢ֳDerivative Const
    int LastError; // Error[-1]  
    int PrevError; // Error[-2]
    int SumError; // Sums of Errors

//	int SetPoint; // 趨ĿDesired value
//    int Proportion; // Proportional Const
//    int Integral; // ֳIntegral Const
//    int Derivative; // ΢ֳDerivative Const
//    int LastError; // Error[-1]  
//    int PrevError; // Error[-2]
//    int SumError; // Sums of Errors

} PID;
extern PID vPID;
//extern struct PID pid;

int PIDCalc1( PID *pp, int NextPoint,unsigned int gappid ); 
int PIDCalc2( PID *pp, int NextPoint ); 
//int Vol(int vSet,int v3);
void PIDInit (PID *pp);	
int PIDCalc3( PID *pp, int NextPoint,u8 B );
int PIDCalc4( PID *pp, int NextPoint,int B );	 					    
#endif

