#ifndef _PID_ONLINR_ADJUST_H_
#define	_PID_ONLINR_ADJUST_H_

#include "sys.h"											  
#define PIDOL_usart_num	     1			   //ѡ񴮿ںţ1:1             2:2
#define PIDOL_AFIO_EN		 0			   //ѡӳ䣬1:ʹӳ        0:ʹӳ
/*
		         1                                  2
ӳ		  RXA9   TXA10							RXA3     TXA2
ӳ		  RXB7	 TXB6							RXD6	 TXD5
*/
typedef enum 
{
	PID_OLADJ_TheSet=1,
	PID_OLADJ_BeAdjust=2,
	PID_OLADJ_Output=3,
	PID_OLADJ_PID_P=4,
	PID_OLADJ_PID_I=5,
	PID_OLADJ_PID_D=6
} PID_OADF;		 //PID_Online_Adjust_double_function


typedef struct
{
	float P;
	float I;
	float D;

	float NowErr;
	float OldErr;
	float PrevErr;
	float D_Err;
	float I_Err;
}PIDCtrl;


int PDCtrl_Res(void);
void PID_Get_Err(float *P,float *Goal);

void PID_Oline_init(float P,float I,float D);
void Do_send_PIDOL(float *Goal,float *P,float *PIDres);
void PIDOL_receive(u8 *p,float *TheSet);
void PIDOL_Usart2_PutChar(u8 ch);
void PIDOL_Usart1_PutChar(u8 ch);
void PIDOL_usart1_init(u32 pclk2,u32 bound);
void PIDOL_usart2_init(u32 pclk2,u32 bound);

#endif

