#ifndef __LCD_H
#define __LCD_H		
#include "gpio.h"	 

#define LCD_FAST_IO	1	//ǷʹÿIO0ʹã1ʹ
#define USE_HORIZONTAL  0	//Ƿʹú0,ʹ.1,ʹ.

//TFTLCDҪõĺ		   
extern u16  POINT_COLOR;//ĬϺɫ    
extern u16  BACK_COLOR; //ɫ.ĬΪɫ 

/*****ɫ*****/
//ɫ
#define WHITE         	 0xFFFF
#define BLACK         	 0x0000	  
#define BLUE         	 0x001F  
#define BRED             0XF81F
#define GRED 			 0XFFE0
#define GBLUE			 0X07FF
#define RED           	 0xF800
#define MAGENTA       	 0xF81F
#define GREEN         	 0x07E0
#define CYAN          	 0x7FFF
#define YELLOW        	 0xFFE0
#define BROWN 			 0XBC40 //ɫ
#define BRRED 			 0XFC07 //غɫ
#define GRAY  			 0X8430 //ɫ
//GUIɫ

#define DARKBLUE      	 0X01CF	//ɫ
#define LIGHTBLUE      	 0X7D7C	//ǳɫ  
#define GRAYBLUE       	 0X5458 //ɫ
//ɫΪPANELɫ 

#define LIGHTGREEN     	 0X841F //ǳɫ
//#define LIGHTGRAY        0XEF5B //ǳɫ(PANNEL)
#define LGRAY 			 0XC618 //ǳɫ(PANNEL),屳ɫ

#define LGRAYBLUE        0XA651 //ǳɫ(мɫ)
#define LBBLUE           0X2B12 //ǳɫ(ѡĿķɫ)

/**LCDĳߴ**/
#if USE_HORIZONTAL==1	//ʹú
#define LCD_W 320
#define LCD_H 240
#else
#define LCD_W 240
#define LCD_H 320
#endif

/*LCDɨ跽*/
#define L_R_U_D  0 //,ϵ
#define L_R_D_U  1 //,µ
#define R_L_U_D  2 //ҵ,ϵ
#define R_L_D_U  3 //ҵ,µ

#define U_D_L_R  4 //ϵ,
#define U_D_R_L  5 //ϵ,ҵ
#define D_U_L_R  6 //µ,
#define D_U_R_L  7 //µ,ҵ





/**LCD˿ڶ**/

#if LCD_FAST_IO ==1		//IO궨

//---------------------ģʾϵͳ----------------//
#define     LCD_RESET    PCout(1)	      //λܽ  PC1
#define		LCD_BL       PCout(0)        //LCD   PC0 
#define		LCD_CS		 PAout(1)         //Ƭѡ˿  PA1
#define		LCD_RS		 PAout(0)         /// PA0	   
#define		LCD_WR		 PCout(3)         //д	 PC3
#define		LCD_RD	     PCout(2)         //	 PC2	    ʼΪ
#define     LCD_DATA     GPIOE->ODR       //

//---------------------ģʾϵͳ----------------//
#define DATAOUT(x)		GPIOE->ODR=x;	 //
#define DATAIN 		    GPIOE->IDR;		 //

#define LCD_BL		    PCout(0)	//LCDPC0
#define LCD_CS_SET		GPIOA->BSRR=1<<1	//PA1λ1
#define LCD_RS_SET		GPIOA->BSRR=1<<0	//PA0λ1
#define LCD_WR_SET 	    GPIOC->BSRR=1<<3	//PC3λ1
#define LCD_RD_SET 	    GPIOC->BSRR=1<<2 	//PC2λ1

#define LCD_CS_CLR		GPIOA->BRR =1<<1	//PA1
#define LCD_RS_CLR		GPIOA->BRR =1<<0 	//PA0
#define LCD_WR_CLR		GPIOC->BRR =1<<3	//PC3
#define LCD_RD_CLR 	    GPIOC->BRR =1<<2	//PC2
#define     LCD_RESET    PCout(1)	      //λܽ  PC1


#else	//ͨIO

#define LCD_CS		PCout(9)	//CSƬѡƶ
#define LCD_RS		PCout(8)	//RSƶ
#define LCD_WR		PCout(7)	//WRƶ
#define LCD_RD		PCout(6)	//RDƶ

#endif

/***дݵĴ***/
#if LCD_FAST_IO==1	  //ʹÿIOдݵĴ
#define LCD_WR_DATA(data)\
{\
LCD_RS_SET;\
LCD_CS_CLR;\
DATAOUT(data);\
LCD_WR_CLR;\
LCD_WR_SET;\
LCD_CS_SET;\
}
#else	//IOдݵĴ
#define LCD_WR_DATA(data)
{\
LCD_RS=1;\
LCD_CS=0;\
DATAOUT(data);\
LCD_WR=0;\
LCD_WR=1;\
LCD_CS=1;\
}
#endif

/**9320 LCDĴ**/
#define R0             0x00
#define R1             0x01
#define R2             0x02
#define R3             0x03
#define R4             0x04 
#define R5             0x05
#define R6             0x06
#define R7             0x07
#define R8             0x08
#define R9             0x09
#define R10            0x0A
#define R12            0x0C
#define R13            0x0D
#define R14            0x0E
#define R15            0x0F
#define R16            0x10
#define R17            0x11
#define R18            0x12
#define R19            0x13
#define R20            0x14
#define R21            0x15
#define R22            0x16
#define R23            0x17
#define R24            0x18
#define R25            0x19
#define R26            0x1A
#define R27            0x1B
#define R28            0x1C
#define R29            0x1D
#define R30            0x1E
#define R31            0x1F
#define R32            0x20
#define R33            0x21
#define R34            0x22
#define R36            0x24
#define R37            0x25
#define R40            0x28
#define R41            0x29
#define R43            0x2B
#define R45            0x2D
#define R48            0x30
#define R49            0x31
#define R50            0x32
#define R51            0x33
#define R52            0x34
#define R53            0x35
#define R54            0x36
#define R55            0x37
#define R56            0x38
#define R57            0x39
#define R59            0x3B
#define R60            0x3C
#define R61            0x3D
#define R62            0x3E
#define R63            0x3F
#define R64            0x40
#define R65            0x41
#define R66            0x42
#define R67            0x43
#define R68            0x44
#define R69            0x45
#define R70            0x46
#define R71            0x47
#define R72            0x48
#define R73            0x49
#define R74            0x4A
#define R75            0x4B
#define R76            0x4C
#define R77            0x4D
#define R78            0x4E
#define R79            0x4F
#define R80            0x50
#define R81            0x51
#define R82            0x52
#define R83            0x53
#define R96            0x60
#define R97            0x61
#define R106           0x6A
#define R118           0x76
#define R128           0x80
#define R129           0x81
#define R130           0x82
#define R131           0x83
#define R132           0x84
#define R133           0x85
#define R134           0x86
#define R135           0x87
#define R136           0x88
#define R137           0x89
#define R139           0x8B
#define R140           0x8C
#define R141           0x8D
#define R143           0x8F
#define R144           0x90
#define R145           0x91
#define R146           0x92
#define R147           0x93
#define R148           0x94
#define R149           0x95
#define R150           0x96
#define R151           0x97
#define R152           0x98
#define R153           0x99
#define R154           0x9A
#define R157           0x9D
#define R192           0xC0
#define R193           0xC1
#define R229           0xE5							  		 

/*******************/
//ILI9320.cк
//extern u16 BACK_COLOR,POINT_COLOR; 
void LCD_WR_REG(u8 data);	//дĴַ
void LCD_WriteReg(u8 LCD_Reg,u16 LCD_RegValue);//дݵָļĴ
u16  LCD_ReadReg(u8 LCD_Reg);//ĴؼĴ״ֵ̬
void LCD_WriteRAM_Reg(void);//дGRAM
void LCD_WriteRAM(u16 RGB_Code);//дGRAM
u16  LCD_BGR_RGB(u16 bgr);//ɫֵBGR_RGBʽתRGBɫֵ
void LCD_SetCursor(u16 Xpos, u16 Ypos);//ùλ
u16  LCD_ReadPoint(u16 x,u16 y);//ɫֵͨLCD_BGR_RGBõõRGBֵ
void LCD_DisplayOn(void);//LCDʾ
void LCD_DisplayOff(void);//رLCDʾ
void LCD_Scan_Dir(u8 dir);//LCDɨ跽
void LCD_Set_Window(u16 sx,u16 sy,u16 ex,u16 ey);//ô
void LCD_Clear(u16 color);//ʹָɫ
void LCD_Fill(u16 xsta,u16 ysta,u16 xend,u16 yend,u16 color);//ָɫ
void LCD_DrawPoint(u16 x,u16 y);//
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2);//
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2);//
void Draw_Circle(u16 x,u16 y,u8 r);//Բ
void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode);//ʾһַ
u32  mypow(u8 m,u8 n);
void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size);//ʾ
void LCD_Show2Num(u16 x,u16 y,u16 num,u8 len,u8 size,u8 mode);//ʾ2
void LCD_ShowString(u16 x,u16 y,const u8 *p);//ʾ1ַ1608
//void TFTLCD_WriteChinese(u16 x_add,u16 y_add,u8 *hz);
//void TFTLCD_WriteChineseStr(u16 x_add,u16 y_add,u8 *str);
void LCD_zhongwen(u16 x,u16 y,u8 num,u8 size,u8 mode);

void LCD_Init(void);  //ʼ
void Draw_Circle3_3(u16 x,u16 y);
void Draw_BAXIN(void);
void TFTLCD_WriteOrder(u8 order);
void TFTLCD_WriteData(u16 data);
void TFTLCD_WriteReg(u8 reg_num, u16 reg_value);
void TFTLCD_ClearScreen(u16 color);
void TFTLCD_SetXy(u16 Xpos, u16 Ypos);
void TFTLCD_WriteRAM_Prepare(void);
void TFTLCD_DrawPoint(u16 x, u16 y);
void TFTLCD_WriteStr(u16 x_add, u16 y_add,u8 str);
void TFTLCD_WriteString(u16 x_add,u16 y_add,u8 *string);
void TFTLCD_WriteChinese(u16 x_add,u16 y_add,u8 *hz);
void TFTLCD_WriteChineseStr(u16 x_add,u16 y_add,u8 *str);
void TFTLCD_ShowNum(u16 x,u16 y,u32 num,u8 len);
#endif  
 
 



