#include "timer.h"
#include "24l01.h"
#include "tftlcd.h"
#include "delay.h"	
#include "ds18b20.h"
#include "usart.h"
#include "remote.h"
#include "pwm.h"
#include "pid.h"
#include "24cxx.h"
#include "myiic.h"
#include "usart.h"
#include "adc.h"
#include <math.h>
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//Mini STM32
//ͨöʱ 			   
//ԭ@ALIENTEK
//̳:www.openedv.com
//޸:2010/12/03
//汾V1.0
//ȨУؾ
//Copyright(C) ԭ 2009-2019
//All rights reserved
////////////////////////////////////////////////////////////////////////////////// 	  

extern float PID_res,Encoder_Angle_Speed,Goal,Encoder_Angle;

float old_Encoder_Angle=0,filter_res;
u16 speed_data_buf[22],timer_i,temp;

void TIM2_IRQHandler(void)
{ 		    			  			    
	if(TIM2->SR&0X0001)//ж 
	{
////////////////õٶ///////////////////////////////////////////////////////////////////////////////////////
		old_Encoder_Angle=Encoder_Angle;
		Encoder_Angle=TIM4->CNT*360/1792;							  			//ӱýǶ һȦ1792
		Encoder_Angle_Speed=(int)(Encoder_Angle+360-old_Encoder_Angle)%360;		//ǶתΪٶ	  //ûгʱ䣬Ҳĳط
//////////////ֵƽٶ/////////////////////////////////////////////////////////////////////////////////////////////
		for(timer_i=0;timer_i<21;timer_i++)				
		  speed_data_buf[timer_i]=speed_data_buf[timer_i+1];
		speed_data_buf[21]=Encoder_Angle_Speed;	
		filter_res=mean_filter(speed_data_buf);
		Encoder_Angle_Speed=filter_res;
//////////////PID//////////////////////////////////////////////////////////////////////////////////////////
		PID_Get_Err(&filter_res,&Goal);								//ȡٶԼǼٶ
		PID_res=PDCtrl_Res();										//õֵ Ҫݸͺ
		TIM3->CCR4=PID_res;											//			    			   				     	    	
	}				   
	TIM2->SR&=~(1<<0);//жϱ־λ 	    
}


//ʱ2жϷ	
//ͨöʱжϳʼ
//ʱѡΪAPB12APB1Ϊ36M
//arrԶװֵ
//pscʱԤƵ
//ʹõǶʱ3!
void Timer2_Init(u16 arr,u16 psc)      //1000,71991һһ1
{
	RCC->APB1ENR|=1<<0;//TIM2ʱʹ    
 	TIM2->ARR=arr;  //趨Զװֵ//պ1ms    
	TIM2->PSC=psc;  //ԤƵ7200,õ10Khzļʱ
	//Ҫͬʱòſʹж
	TIM2->DIER|=1<<0;   //ж				
	TIM2->DIER|=1<<6;   //ж	   
	TIM2->CR1|=0x01;    //ʹܶʱ2
  	MY_NVIC_Init(1,3,TIM2_IRQChannel,2);//ռ1ȼ32								 
}

void Timer5_Init(u16 arr,u16 psc)
{
	RCC->APB1ENR|=1<<3;//TIM5ʱʹ    
	TIM5->ARR=arr;  //趨Զװֵ//պ1ms    
	TIM5->PSC=psc;  //ԤƵ7200,õ10Khzļʱ
	//Ҫͬʱòſʹж
	TIM5->DIER|=1<<0;   //ж    
	TIM5->DIER|=1<<6;   //ж
	       
	TIM5->CR1|=0x01;    //ʹܶʱ5
	MY_NVIC_Init(1,3,TIM5_IRQChannel,2);//ռ1ȼ32          
}

void TIM5_IRQHandler(void)
{														
	if(TIM5->SR&0X0001)//ж
	{
		;                             
	}       
	TIM5->SR&=~(1<<0);//жϱ־λ   
}



void Timer4_Init(u16 arr,u16 psc)
{
	RCC->APB1ENR|=1<<2;//TIM4ʱʹ    
 	TIM4->ARR=arr;  //趨Զװֵ//պ1ms    
	TIM4->PSC=psc;  //ԤƵ7200,õ10Khzļʱ
	//Ҫͬʱòſʹж
	TIM4->DIER|=1<<0;   //ж				
	TIM4->DIER|=1<<6;   //ж
		  							    
	TIM4->CR1|=0x01;    //ʹܶʱ3
  	MY_NVIC_Init(1,3,TIM4_IRQChannel,2);//ռ1ȼ32									 
}


void TIM4_IRQHandler(void)
{ 		    		  			    
	if(TIM4->SR&0X0001)//ж
	{

	   ;
	}				   
	TIM4->SR&=~(1<<0);//жϱ־λ 	    
}

//ʱ3жϷ
void TIM3_IRQHandler(void)
{ 		    		  			    
	if(TIM3->SR&0X0001)//ж
	{	
		;	    				   				     	    	
	}				   
	TIM3->SR&=~(1<<0);//жϱ־λ 	    
}
  	 



void Timer3_Init(u16 arr,u16 psc)
{
	RCC->APB1ENR|=1<<1;//TIM3ʱʹ    
 	TIM3->ARR=arr;  //趨Զװֵ//պ1ms    
	TIM3->PSC=psc;  //ԤƵ7200,õ10Khzļʱ
	//Ҫͬʱòſʹж
	TIM3->DIER|=1<<0;   //ж				
	TIM3->DIER|=1<<6;   //ж
		  							    
	TIM3->CR1|=0x01;    //ʹܶʱ3
  	MY_NVIC_Init(1,3,TIM3_IRQChannel,2);//ռ1ȼ32									 
}


void Timer1_Init(u16 arr,u16 psc)      //1000,71991һһ1
{
	RCC->APB2ENR|=1<<11;//TIM1ʱʹ    
 	TIM1->ARR=arr;  //趨Զװֵ//պ1ms    
	TIM1->PSC=psc;  //ԤƵ7200,õ10Khzļʱ
	//Ҫͬʱòſʹж
	TIM1->DIER|=1<<0;   //ж				
	TIM1->DIER|=1<<6;   //ж	   
	TIM1->CR1|=0x01;    //ʹܶʱ6
  	MY_NVIC_Init(2,3,TIM1_UP_IRQChannel,2);//ռ1ȼ32
									 
}

void TIM1_UP_IRQHandler(void)
{ 		    			  			    
	if(TIM1->SR&0X0001)//ж 
	{
		Do_send_PIDOL(&Goal,&Encoder_Angle_Speed,&PID_res);         //͸λ	    			   				     	    	
	}				   
	TIM1->SR&=~(1<<0);//жϱ־λ 	    
}




