#ifndef __VOICE_H
#define __VOICE_H

#include <stm32f10x_lib.h>
#include "sys.h"
/**************************************************************************
*ʹö¼¼õַʹ÷з
**************************************************************************/
#define uchar u16
#define uint u16


#define PU 0x01
#define STOP 0x02
#define RESET 0x03
#define CLI_INT 0x04
#define RD_STATUS 0x05
#define RD_PLAY_PTR 0x06
#define PD 0x07
#define RD_REC_PTR 0x08
#define RD_DEVID 0x09
#define G_ERASE 0x43
#define RD_APC 0x44
#define WR_APC1 0x45
#define WR_APC2 0x65
#define WR_NVCFG 0x46
#define CHK_MEM 0x49
#define SET_PLAY 0x80
#define SET_REC 0x81
#define SET_ERASE 0x82

//#define SS PBout(8)// PD5
//#define SCLK PBout(7)// PD6
//#define MOSI PBout(5)// PD7
//#define MISO PBin(6)// PD8

//#define SS PAout(1)// PD5
//#define SCLK PAout(3)// PD6
//#define MOSI PAout(5)// PD7
//#define MISO PAin(7)// PD8

#define SS PBout(12)// PB12
#define SCLK PBout(13)// PB13
#define MOSI PBout(15)// PB15
#define MISO PBin(14)// PB14


extern u16 SR0_L;
extern u16 SR0_H;
extern u16 SR_z;
extern u16 ID,APCL,APCH;
//extern u16 caToneAdd[8];	 //Լ
//ÿ10Լ80ʮƵַʮ0x50,һԽ
//ֻᲥǰĺһ֣EOMֹͣ.Ը 
//¼8תʮõŵַ΢

//void I_delay(void);
//----------------------------------------------------------------
//:Delay
//ڲ:Z
//ڲ:
//:ʵMSʱZΪʱMS
//----------------------------------------------------------------
//void Delay( uint z );
//----------------------------------------------------------------
//   : SPISendData( )
// : SPIݣݣӳ
//----------------------------------------------------------------
void VOICE_Init(void);
uchar SPISendData(uchar BUF_ISD);
/**************************************************************************
* ԭ: void RdStatus(void);
*  : ȡ״̬
**************************************************************************/
void RdStatus(void);
/**************************************************************************
* ԭ: void ClrInt(void);
*  : ж
**************************************************************************/
void ClrInt(void);
/**************************************************************************
* ԭ: void ISD_WR_NVCFG(void);
*  : дĴ
**************************************************************************/
void ISD_WR_NVCFG(void);
/**************************************************************************
* ԭ: void ISD_WR_APC2(uchar voiceValue);
*  : APC2
**************************************************************************/
void ISD_WR_APC2(void);
/**************************************************************************
* ԭ: void RD_APC(void);
*  : ȡAPC
**************************************************************************/
void RdAPC(void);
/**************************************************************************
* ԭ: void ISD_Init(void);
*  : ʼ
**************************************************************************/
void ISD_Init(void);
/**************************************************************************
* ԭ: void ISD_CHK_MEM(void);
*  : ռ
**************************************************************************/
void ISD_CHK_MEM(void);
/**************************************************************************
* ԭ: void ISD_Reset(void);
*  : λ
**************************************************************************/
void ISD_Reset(void);
/**************************************************************************
* ԭ: void ISD_Stop(void);
*  : ֹͣ
**************************************************************************/
void ISD_Stop(void);
/**************************************************************************
* ԭ: void ISD_PU(void);
*  : ϵ
**************************************************************************/
void ISD_PU(void);
/**************************************************************************
* ԭ: void ISD_PD(void);
*  : 
**************************************************************************/
void ISD_PD(void);
/**************************************************************************
* ԭ: void RdStatus(void);
*  : ȡID
**************************************************************************/
uchar RD_DevID(void);
/**************************************************************************
* ԭ: void GetToneAdd(uchar cNum, Uint * ipStartAdd, Uint * ipEndAdd);
*  : ȡǰĩַ
**************************************************************************/
void GetToneAdd(uchar a,uchar b, uint * ipStartAdd, uint * ipEndAdd);
/**************************************************************************
* ԭ: void SetPLAY(uchar cNum);
 4 ҳ
ISD1760.c
*  : 㲥
**************************************************************************/
void SetPLAY(uchar a,uchar b);
/**************************************************************************
* ԭ: void SetREC(uchar cNum);
*  : ¼
**************************************************************************/
void SetREC(uchar cNum);
/**************************************************************************
* ԭ: void Erase_All(void);
*  : ȫɾ
**************************************************************************/
void Erase_All(void);
#endif
